using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace TTSample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmMain : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox txtAPIVersion;
		private System.Windows.Forms.TextBox txtLanguageCodeIn;
		private System.Windows.Forms.Button cmdHello;
		private System.Windows.Forms.TextBox txtSessionID;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.ListBox lstResults;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Button cmdLoginWindows;
		private System.Windows.Forms.Button cmdLoginStandard;
		private System.Windows.Forms.Button cmdGoodbye;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.TextBox txtPassword;
		private System.Windows.Forms.TextBox txtUserName;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.TabPage tabPage1;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.TextBox txtURL;
		private System.Windows.Forms.TabControl tabsMain;
		private System.Windows.Forms.ListBox lstEntityTypes;
		private System.Windows.Forms.Button cmdGetEntityTypes;
		private System.Windows.Forms.TabPage tabPage2;
		private System.Windows.Forms.Button cmdGetEntities;
		private System.Windows.Forms.TreeView treeEntities;
		private System.Windows.Forms.Button cmdClearEntities;
		private System.Windows.Forms.Panel panCreateEntity;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.ComboBox cmbCreateEntityType;
		private System.Windows.Forms.TextBox txtCreateEntityName;
		private System.Windows.Forms.Button cmdCreateEntity;
		private System.Windows.Forms.Button cmdTouch;
		private System.Windows.Forms.CheckBox chkGetEntityTypesBottomMost;
		private System.Windows.Forms.TextBox txtSelectedEntityID;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.TabPage tabPage3;
		private System.Windows.Forms.Button cmdPrepareCreateTimeLog;
		private System.Windows.Forms.Panel panAllocationEntity;
		private System.Windows.Forms.Button cmdSetAllocationEntity;
		private System.Windows.Forms.TextBox txtAllocationEntityID;
		private System.Windows.Forms.ListBox lstAllocationEntityTypes;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.TextBox txtLogSeconds;
		private System.Windows.Forms.Label label15;
		private System.Windows.Forms.TextBox txtStatusDescription;
		private System.Windows.Forms.TextBox txtLogDate;
		private System.Windows.Forms.Label label16;
		private System.Windows.Forms.Button cmdSaveTimeLog;
		private System.Windows.Forms.TabPage tabPage4;
		private System.Windows.Forms.Button cmdGetTimeLogs;
		private System.Windows.Forms.DataGrid gridTimeLogs;
		private System.Windows.Forms.Label label17;
		private System.Windows.Forms.Label label18;
		private System.Windows.Forms.DateTimePicker dateGetTimeLogsFrom;
		private System.Windows.Forms.DateTimePicker dateGetTimeLogsTo;
		private System.Windows.Forms.TabPage tabPage5;
		private System.Windows.Forms.Label label20;
		private System.Windows.Forms.TextBox txtCustomFieldEntityID;
		private System.Windows.Forms.DataGrid gridCustomFieldValues;
		private System.Windows.Forms.Button cmdGetCustomFieldValuesEntity;
		private System.Windows.Forms.Label label21;
		private System.Windows.Forms.Button cmdGetTimeLogBilled;
		private System.Windows.Forms.Button cmdSetTimeLogBilled;
		private System.Windows.Forms.Button cmdClearTimeLogBilled;
		private System.Windows.Forms.TextBox txtTimeLogID;
		private System.Windows.Forms.TabPage tabPage6;
		private System.Windows.Forms.Label label22;
		private System.Windows.Forms.TextBox txtMetricsEntityID;
		private System.Windows.Forms.Label label23;
		private System.Windows.Forms.TextBox txtMetricsAsOf;
		private System.Windows.Forms.TextBox txtMetricsTotalSecs;
		private System.Windows.Forms.Label label24;
		private System.Windows.Forms.TextBox txtMetricsCPI;
		private System.Windows.Forms.Label label25;
		private System.Windows.Forms.TextBox txtMetricsSPI;
		private System.Windows.Forms.Label label26;
		private System.Windows.Forms.Button txtGetEntityMetrics;
		private System.Windows.Forms.TabPage tabPage7;
		private System.Windows.Forms.TextBox txtFindEntityName;
		private System.Windows.Forms.Label label27;
		private System.Windows.Forms.DataGrid gridFindEntities;
		private TabPage tabPage8;
		private TextBox txtAssignFromEntityID;
		private Label label19;
		private TextBox txtAssignToEntityID;
		private Label label28;
		private Button cmdGetRoleTypeList;
		private Label label29;
		private Button cmdAssign;
		private ComboBox cmbRoleTypes;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.cmdHello = new System.Windows.Forms.Button();
      this.txtAPIVersion = new System.Windows.Forms.TextBox();
      this.txtLanguageCodeIn = new System.Windows.Forms.TextBox();
      this.txtSessionID = new System.Windows.Forms.TextBox();
      this.label1 = new System.Windows.Forms.Label();
      this.label2 = new System.Windows.Forms.Label();
      this.label5 = new System.Windows.Forms.Label();
      this.lstResults = new System.Windows.Forms.ListBox();
      this.label3 = new System.Windows.Forms.Label();
      this.label4 = new System.Windows.Forms.Label();
      this.label6 = new System.Windows.Forms.Label();
      this.cmdLoginWindows = new System.Windows.Forms.Button();
      this.cmdLoginStandard = new System.Windows.Forms.Button();
      this.cmdGoodbye = new System.Windows.Forms.Button();
      this.label7 = new System.Windows.Forms.Label();
      this.label8 = new System.Windows.Forms.Label();
      this.txtPassword = new System.Windows.Forms.TextBox();
      this.txtUserName = new System.Windows.Forms.TextBox();
      this.label9 = new System.Windows.Forms.Label();
      this.tabsMain = new System.Windows.Forms.TabControl();
      this.tabPage1 = new System.Windows.Forms.TabPage();
      this.chkGetEntityTypesBottomMost = new System.Windows.Forms.CheckBox();
      this.cmdGetEntityTypes = new System.Windows.Forms.Button();
      this.lstEntityTypes = new System.Windows.Forms.ListBox();
      this.tabPage2 = new System.Windows.Forms.TabPage();
      this.txtSelectedEntityID = new System.Windows.Forms.TextBox();
      this.label12 = new System.Windows.Forms.Label();
      this.panCreateEntity = new System.Windows.Forms.Panel();
      this.cmdCreateEntity = new System.Windows.Forms.Button();
      this.txtCreateEntityName = new System.Windows.Forms.TextBox();
      this.cmbCreateEntityType = new System.Windows.Forms.ComboBox();
      this.label11 = new System.Windows.Forms.Label();
      this.cmdClearEntities = new System.Windows.Forms.Button();
      this.treeEntities = new System.Windows.Forms.TreeView();
      this.cmdGetEntities = new System.Windows.Forms.Button();
      this.tabPage3 = new System.Windows.Forms.TabPage();
      this.txtLogDate = new System.Windows.Forms.TextBox();
      this.label16 = new System.Windows.Forms.Label();
      this.cmdSaveTimeLog = new System.Windows.Forms.Button();
      this.txtStatusDescription = new System.Windows.Forms.TextBox();
      this.label15 = new System.Windows.Forms.Label();
      this.txtLogSeconds = new System.Windows.Forms.TextBox();
      this.label14 = new System.Windows.Forms.Label();
      this.panAllocationEntity = new System.Windows.Forms.Panel();
      this.label13 = new System.Windows.Forms.Label();
      this.txtAllocationEntityID = new System.Windows.Forms.TextBox();
      this.cmdSetAllocationEntity = new System.Windows.Forms.Button();
      this.lstAllocationEntityTypes = new System.Windows.Forms.ListBox();
      this.cmdPrepareCreateTimeLog = new System.Windows.Forms.Button();
      this.tabPage4 = new System.Windows.Forms.TabPage();
      this.txtTimeLogID = new System.Windows.Forms.TextBox();
      this.cmdClearTimeLogBilled = new System.Windows.Forms.Button();
      this.cmdSetTimeLogBilled = new System.Windows.Forms.Button();
      this.cmdGetTimeLogBilled = new System.Windows.Forms.Button();
      this.label21 = new System.Windows.Forms.Label();
      this.dateGetTimeLogsTo = new System.Windows.Forms.DateTimePicker();
      this.dateGetTimeLogsFrom = new System.Windows.Forms.DateTimePicker();
      this.label18 = new System.Windows.Forms.Label();
      this.label17 = new System.Windows.Forms.Label();
      this.cmdGetTimeLogs = new System.Windows.Forms.Button();
      this.gridTimeLogs = new System.Windows.Forms.DataGrid();
      this.tabPage5 = new System.Windows.Forms.TabPage();
      this.cmdGetCustomFieldValuesEntity = new System.Windows.Forms.Button();
      this.gridCustomFieldValues = new System.Windows.Forms.DataGrid();
      this.label20 = new System.Windows.Forms.Label();
      this.txtCustomFieldEntityID = new System.Windows.Forms.TextBox();
      this.tabPage6 = new System.Windows.Forms.TabPage();
      this.txtMetricsSPI = new System.Windows.Forms.TextBox();
      this.label26 = new System.Windows.Forms.Label();
      this.txtMetricsCPI = new System.Windows.Forms.TextBox();
      this.label25 = new System.Windows.Forms.Label();
      this.txtMetricsTotalSecs = new System.Windows.Forms.TextBox();
      this.label24 = new System.Windows.Forms.Label();
      this.txtMetricsAsOf = new System.Windows.Forms.TextBox();
      this.label23 = new System.Windows.Forms.Label();
      this.txtGetEntityMetrics = new System.Windows.Forms.Button();
      this.label22 = new System.Windows.Forms.Label();
      this.txtMetricsEntityID = new System.Windows.Forms.TextBox();
      this.tabPage7 = new System.Windows.Forms.TabPage();
      this.gridFindEntities = new System.Windows.Forms.DataGrid();
      this.txtFindEntityName = new System.Windows.Forms.TextBox();
      this.label27 = new System.Windows.Forms.Label();
      this.tabPage8 = new System.Windows.Forms.TabPage();
      this.cmdAssign = new System.Windows.Forms.Button();
      this.cmbRoleTypes = new System.Windows.Forms.ComboBox();
      this.label29 = new System.Windows.Forms.Label();
      this.cmdGetRoleTypeList = new System.Windows.Forms.Button();
      this.txtAssignToEntityID = new System.Windows.Forms.TextBox();
      this.label28 = new System.Windows.Forms.Label();
      this.txtAssignFromEntityID = new System.Windows.Forms.TextBox();
      this.label19 = new System.Windows.Forms.Label();
      this.label10 = new System.Windows.Forms.Label();
      this.txtURL = new System.Windows.Forms.TextBox();
      this.cmdTouch = new System.Windows.Forms.Button();
      this.tabsMain.SuspendLayout();
      this.tabPage1.SuspendLayout();
      this.tabPage2.SuspendLayout();
      this.panCreateEntity.SuspendLayout();
      this.tabPage3.SuspendLayout();
      this.panAllocationEntity.SuspendLayout();
      this.tabPage4.SuspendLayout();
      ((System.ComponentModel.ISupportInitialize)(this.gridTimeLogs)).BeginInit();
      this.tabPage5.SuspendLayout();
      ((System.ComponentModel.ISupportInitialize)(this.gridCustomFieldValues)).BeginInit();
      this.tabPage6.SuspendLayout();
      this.tabPage7.SuspendLayout();
      ((System.ComponentModel.ISupportInitialize)(this.gridFindEntities)).BeginInit();
      this.tabPage8.SuspendLayout();
      this.SuspendLayout();
      // 
      // cmdHello
      // 
      this.cmdHello.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.cmdHello.Location = new System.Drawing.Point(8, 100);
      this.cmdHello.Name = "cmdHello";
      this.cmdHello.Size = new System.Drawing.Size(76, 24);
      this.cmdHello.TabIndex = 6;
      this.cmdHello.Text = "Hello";
      this.cmdHello.Click += new System.EventHandler(this.cmdHello_Click);
      // 
      // txtAPIVersion
      // 
      this.txtAPIVersion.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.txtAPIVersion.Location = new System.Drawing.Point(112, 56);
      this.txtAPIVersion.Name = "txtAPIVersion";
      this.txtAPIVersion.Size = new System.Drawing.Size(44, 20);
      this.txtAPIVersion.TabIndex = 3;
      this.txtAPIVersion.Text = "1.0.0";
      // 
      // txtLanguageCodeIn
      // 
      this.txtLanguageCodeIn.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.txtLanguageCodeIn.Location = new System.Drawing.Point(112, 76);
      this.txtLanguageCodeIn.Name = "txtLanguageCodeIn";
      this.txtLanguageCodeIn.Size = new System.Drawing.Size(44, 20);
      this.txtLanguageCodeIn.TabIndex = 5;
      this.txtLanguageCodeIn.Text = "ENUS";
      // 
      // txtSessionID
      // 
      this.txtSessionID.Font = new System.Drawing.Font("Arial", 6.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.txtSessionID.Location = new System.Drawing.Point(232, 8);
      this.txtSessionID.Name = "txtSessionID";
      this.txtSessionID.Size = new System.Drawing.Size(208, 18);
      this.txtSessionID.TabIndex = 8;
      // 
      // label1
      // 
      this.label1.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label1.Location = new System.Drawing.Point(8, 56);
      this.label1.Name = "label1";
      this.label1.Size = new System.Drawing.Size(96, 20);
      this.label1.TabIndex = 2;
      this.label1.Text = "API Version";
      // 
      // label2
      // 
      this.label2.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label2.Location = new System.Drawing.Point(8, 76);
      this.label2.Name = "label2";
      this.label2.Size = new System.Drawing.Size(104, 20);
      this.label2.TabIndex = 4;
      this.label2.Text = "PreferredLanguage";
      // 
      // label5
      // 
      this.label5.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label5.Location = new System.Drawing.Point(172, 8);
      this.label5.Name = "label5";
      this.label5.Size = new System.Drawing.Size(60, 20);
      this.label5.TabIndex = 7;
      this.label5.Text = "Session ID";
      // 
      // lstResults
      // 
      this.lstResults.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.lstResults.HorizontalScrollbar = true;
      this.lstResults.ItemHeight = 14;
      this.lstResults.Location = new System.Drawing.Point(4, 384);
      this.lstResults.Name = "lstResults";
      this.lstResults.Size = new System.Drawing.Size(552, 116);
      this.lstResults.TabIndex = 18;
      // 
      // label3
      // 
      this.label3.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label3.Location = new System.Drawing.Point(8, 36);
      this.label3.Name = "label3";
      this.label3.Size = new System.Drawing.Size(152, 20);
      this.label3.TabIndex = 1;
      this.label3.Text = "1. Connect to Server";
      // 
      // label4
      // 
      this.label4.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label4.Location = new System.Drawing.Point(172, 36);
      this.label4.Name = "label4";
      this.label4.Size = new System.Drawing.Size(176, 20);
      this.label4.TabIndex = 9;
      this.label4.Text = "2. Login using User/Password";
      // 
      // label6
      // 
      this.label6.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label6.Location = new System.Drawing.Point(352, 36);
      this.label6.Name = "label6";
      this.label6.Size = new System.Drawing.Size(196, 20);
      this.label6.TabIndex = 15;
      this.label6.Text = "or Login using Windows Integrated";
      // 
      // cmdLoginWindows
      // 
      this.cmdLoginWindows.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.cmdLoginWindows.Location = new System.Drawing.Point(352, 56);
      this.cmdLoginWindows.Name = "cmdLoginWindows";
      this.cmdLoginWindows.Size = new System.Drawing.Size(96, 24);
      this.cmdLoginWindows.TabIndex = 16;
      this.cmdLoginWindows.Text = "LoginWindows";
      this.cmdLoginWindows.Click += new System.EventHandler(this.cmdLoginWindows_Click);
      // 
      // cmdLoginStandard
      // 
      this.cmdLoginStandard.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.cmdLoginStandard.Location = new System.Drawing.Point(172, 100);
      this.cmdLoginStandard.Name = "cmdLoginStandard";
      this.cmdLoginStandard.Size = new System.Drawing.Size(96, 24);
      this.cmdLoginStandard.TabIndex = 14;
      this.cmdLoginStandard.Text = "LoginStandard";
      this.cmdLoginStandard.Click += new System.EventHandler(this.cmdLoginStandard_Click);
      // 
      // cmdGoodbye
      // 
      this.cmdGoodbye.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.cmdGoodbye.Location = new System.Drawing.Point(499, 8);
      this.cmdGoodbye.Name = "cmdGoodbye";
      this.cmdGoodbye.Size = new System.Drawing.Size(59, 24);
      this.cmdGoodbye.TabIndex = 17;
      this.cmdGoodbye.Text = "Goodbye";
      this.cmdGoodbye.Click += new System.EventHandler(this.cmdGoodbye_Click);
      // 
      // label7
      // 
      this.label7.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label7.Location = new System.Drawing.Point(172, 76);
      this.label7.Name = "label7";
      this.label7.Size = new System.Drawing.Size(64, 20);
      this.label7.TabIndex = 12;
      this.label7.Text = "Password";
      // 
      // label8
      // 
      this.label8.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label8.Location = new System.Drawing.Point(172, 56);
      this.label8.Name = "label8";
      this.label8.Size = new System.Drawing.Size(64, 20);
      this.label8.TabIndex = 10;
      this.label8.Text = "UserName";
      // 
      // txtPassword
      // 
      this.txtPassword.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.txtPassword.Location = new System.Drawing.Point(236, 76);
      this.txtPassword.Name = "txtPassword";
      this.txtPassword.PasswordChar = '*';
      this.txtPassword.Size = new System.Drawing.Size(104, 20);
      this.txtPassword.TabIndex = 13;
      // 
      // txtUserName
      // 
      this.txtUserName.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.txtUserName.Location = new System.Drawing.Point(236, 56);
      this.txtUserName.Name = "txtUserName";
      this.txtUserName.Size = new System.Drawing.Size(104, 20);
      this.txtUserName.TabIndex = 11;
      this.txtUserName.Text = "DAVE";
      // 
      // label9
      // 
      this.label9.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label9.Location = new System.Drawing.Point(4, 368);
      this.label9.Name = "label9";
      this.label9.Size = new System.Drawing.Size(176, 12);
      this.label9.TabIndex = 19;
      this.label9.Text = "Results";
      // 
      // tabsMain
      // 
      this.tabsMain.Controls.Add(this.tabPage1);
      this.tabsMain.Controls.Add(this.tabPage2);
      this.tabsMain.Controls.Add(this.tabPage3);
      this.tabsMain.Controls.Add(this.tabPage4);
      this.tabsMain.Controls.Add(this.tabPage5);
      this.tabsMain.Controls.Add(this.tabPage6);
      this.tabsMain.Controls.Add(this.tabPage7);
      this.tabsMain.Controls.Add(this.tabPage8);
      this.tabsMain.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.tabsMain.Location = new System.Drawing.Point(4, 128);
      this.tabsMain.Name = "tabsMain";
      this.tabsMain.SelectedIndex = 0;
      this.tabsMain.Size = new System.Drawing.Size(552, 236);
      this.tabsMain.TabIndex = 20;
      // 
      // tabPage1
      // 
      this.tabPage1.Controls.Add(this.chkGetEntityTypesBottomMost);
      this.tabPage1.Controls.Add(this.cmdGetEntityTypes);
      this.tabPage1.Controls.Add(this.lstEntityTypes);
      this.tabPage1.Location = new System.Drawing.Point(4, 23);
      this.tabPage1.Name = "tabPage1";
      this.tabPage1.Size = new System.Drawing.Size(544, 209);
      this.tabPage1.TabIndex = 0;
      this.tabPage1.Text = "EntityTypes";
      this.tabPage1.UseVisualStyleBackColor = true;
      // 
      // chkGetEntityTypesBottomMost
      // 
      this.chkGetEntityTypesBottomMost.Location = new System.Drawing.Point(8, 40);
      this.chkGetEntityTypesBottomMost.Name = "chkGetEntityTypesBottomMost";
      this.chkGetEntityTypesBottomMost.Size = new System.Drawing.Size(96, 16);
      this.chkGetEntityTypesBottomMost.TabIndex = 16;
      this.chkGetEntityTypesBottomMost.Text = "Bottom-most";
      // 
      // cmdGetEntityTypes
      // 
      this.cmdGetEntityTypes.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.cmdGetEntityTypes.Location = new System.Drawing.Point(8, 8);
      this.cmdGetEntityTypes.Name = "cmdGetEntityTypes";
      this.cmdGetEntityTypes.Size = new System.Drawing.Size(104, 24);
      this.cmdGetEntityTypes.TabIndex = 15;
      this.cmdGetEntityTypes.Text = "GetEntityTypeList";
      this.cmdGetEntityTypes.Click += new System.EventHandler(this.cmdGetEntityTypeList_Click);
      // 
      // lstEntityTypes
      // 
      this.lstEntityTypes.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.lstEntityTypes.ItemHeight = 14;
      this.lstEntityTypes.Location = new System.Drawing.Point(116, 8);
      this.lstEntityTypes.Name = "lstEntityTypes";
      this.lstEntityTypes.Size = new System.Drawing.Size(260, 200);
      this.lstEntityTypes.TabIndex = 0;
      // 
      // tabPage2
      // 
      this.tabPage2.Controls.Add(this.txtSelectedEntityID);
      this.tabPage2.Controls.Add(this.label12);
      this.tabPage2.Controls.Add(this.panCreateEntity);
      this.tabPage2.Controls.Add(this.cmdClearEntities);
      this.tabPage2.Controls.Add(this.treeEntities);
      this.tabPage2.Controls.Add(this.cmdGetEntities);
      this.tabPage2.Location = new System.Drawing.Point(4, 23);
      this.tabPage2.Name = "tabPage2";
      this.tabPage2.Size = new System.Drawing.Size(544, 209);
      this.tabPage2.TabIndex = 1;
      this.tabPage2.Text = "Entities";
      this.tabPage2.UseVisualStyleBackColor = true;
      // 
      // txtSelectedEntityID
      // 
      this.txtSelectedEntityID.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.txtSelectedEntityID.Location = new System.Drawing.Point(4, 88);
      this.txtSelectedEntityID.Name = "txtSelectedEntityID";
      this.txtSelectedEntityID.Size = new System.Drawing.Size(108, 20);
      this.txtSelectedEntityID.TabIndex = 20;
      // 
      // label12
      // 
      this.label12.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label12.Location = new System.Drawing.Point(12, 72);
      this.label12.Name = "label12";
      this.label12.Size = new System.Drawing.Size(92, 14);
      this.label12.TabIndex = 21;
      this.label12.Text = "Selected EntityID";
      // 
      // panCreateEntity
      // 
      this.panCreateEntity.Controls.Add(this.cmdCreateEntity);
      this.panCreateEntity.Controls.Add(this.txtCreateEntityName);
      this.panCreateEntity.Controls.Add(this.cmbCreateEntityType);
      this.panCreateEntity.Controls.Add(this.label11);
      this.panCreateEntity.Location = new System.Drawing.Point(0, 176);
      this.panCreateEntity.Name = "panCreateEntity";
      this.panCreateEntity.Size = new System.Drawing.Size(544, 32);
      this.panCreateEntity.TabIndex = 19;
      this.panCreateEntity.Visible = false;
      // 
      // cmdCreateEntity
      // 
      this.cmdCreateEntity.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.cmdCreateEntity.Location = new System.Drawing.Point(452, 4);
      this.cmdCreateEntity.Name = "cmdCreateEntity";
      this.cmdCreateEntity.Size = new System.Drawing.Size(84, 24);
      this.cmdCreateEntity.TabIndex = 15;
      this.cmdCreateEntity.Text = "CreateEntity";
      this.cmdCreateEntity.Click += new System.EventHandler(this.cmdCreateEntity_Click);
      // 
      // txtCreateEntityName
      // 
      this.txtCreateEntityName.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.txtCreateEntityName.Location = new System.Drawing.Point(280, 4);
      this.txtCreateEntityName.Name = "txtCreateEntityName";
      this.txtCreateEntityName.Size = new System.Drawing.Size(168, 20);
      this.txtCreateEntityName.TabIndex = 13;
      // 
      // cmbCreateEntityType
      // 
      this.cmbCreateEntityType.Location = new System.Drawing.Point(168, 4);
      this.cmbCreateEntityType.Name = "cmbCreateEntityType";
      this.cmbCreateEntityType.Size = new System.Drawing.Size(112, 22);
      this.cmbCreateEntityType.TabIndex = 12;
      this.cmbCreateEntityType.SelectedIndexChanged += new System.EventHandler(this.cmbCreateEntityType_SelectedIndexChanged);
      // 
      // label11
      // 
      this.label11.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label11.Location = new System.Drawing.Point(124, 8);
      this.label11.Name = "label11";
      this.label11.Size = new System.Drawing.Size(44, 20);
      this.label11.TabIndex = 11;
      this.label11.Text = "Create:";
      // 
      // cmdClearEntities
      // 
      this.cmdClearEntities.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.cmdClearEntities.Location = new System.Drawing.Point(8, 36);
      this.cmdClearEntities.Name = "cmdClearEntities";
      this.cmdClearEntities.Size = new System.Drawing.Size(104, 24);
      this.cmdClearEntities.TabIndex = 18;
      this.cmdClearEntities.Text = "Clear";
      this.cmdClearEntities.Click += new System.EventHandler(this.cmdClearEntities_Click);
      // 
      // treeEntities
      // 
      this.treeEntities.HideSelection = false;
      this.treeEntities.Location = new System.Drawing.Point(116, 8);
      this.treeEntities.Name = "treeEntities";
      this.treeEntities.Size = new System.Drawing.Size(420, 168);
      this.treeEntities.TabIndex = 17;
      this.treeEntities.BeforeExpand += new System.Windows.Forms.TreeViewCancelEventHandler(this.treeEntities_BeforeExpand);
      this.treeEntities.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.treeEntities_AfterSelect);
      // 
      // cmdGetEntities
      // 
      this.cmdGetEntities.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.cmdGetEntities.Location = new System.Drawing.Point(8, 8);
      this.cmdGetEntities.Name = "cmdGetEntities";
      this.cmdGetEntities.Size = new System.Drawing.Size(104, 24);
      this.cmdGetEntities.TabIndex = 16;
      this.cmdGetEntities.Text = "GetEntities";
      this.cmdGetEntities.Click += new System.EventHandler(this.cmdGetEntities_Click);
      // 
      // tabPage3
      // 
      this.tabPage3.Controls.Add(this.txtLogDate);
      this.tabPage3.Controls.Add(this.label16);
      this.tabPage3.Controls.Add(this.cmdSaveTimeLog);
      this.tabPage3.Controls.Add(this.txtStatusDescription);
      this.tabPage3.Controls.Add(this.label15);
      this.tabPage3.Controls.Add(this.txtLogSeconds);
      this.tabPage3.Controls.Add(this.label14);
      this.tabPage3.Controls.Add(this.panAllocationEntity);
      this.tabPage3.Controls.Add(this.lstAllocationEntityTypes);
      this.tabPage3.Controls.Add(this.cmdPrepareCreateTimeLog);
      this.tabPage3.Location = new System.Drawing.Point(4, 23);
      this.tabPage3.Name = "tabPage3";
      this.tabPage3.Size = new System.Drawing.Size(544, 209);
      this.tabPage3.TabIndex = 2;
      this.tabPage3.Text = "SaveTimeLog";
      this.tabPage3.UseVisualStyleBackColor = true;
      // 
      // txtLogDate
      // 
      this.txtLogDate.Location = new System.Drawing.Point(408, 16);
      this.txtLogDate.Name = "txtLogDate";
      this.txtLogDate.Size = new System.Drawing.Size(120, 20);
      this.txtLogDate.TabIndex = 5;
      // 
      // label16
      // 
      this.label16.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label16.Location = new System.Drawing.Point(336, 16);
      this.label16.Name = "label16";
      this.label16.Size = new System.Drawing.Size(80, 20);
      this.label16.TabIndex = 12;
      this.label16.Text = "Log Date:";
      // 
      // cmdSaveTimeLog
      // 
      this.cmdSaveTimeLog.Location = new System.Drawing.Point(380, 176);
      this.cmdSaveTimeLog.Name = "cmdSaveTimeLog";
      this.cmdSaveTimeLog.Size = new System.Drawing.Size(104, 24);
      this.cmdSaveTimeLog.TabIndex = 8;
      this.cmdSaveTimeLog.Text = "SaveTimeLog";
      this.cmdSaveTimeLog.Click += new System.EventHandler(this.cmdSaveTimeLog_Click);
      // 
      // txtStatusDescription
      // 
      this.txtStatusDescription.Location = new System.Drawing.Point(336, 84);
      this.txtStatusDescription.Multiline = true;
      this.txtStatusDescription.Name = "txtStatusDescription";
      this.txtStatusDescription.Size = new System.Drawing.Size(192, 84);
      this.txtStatusDescription.TabIndex = 7;
      // 
      // label15
      // 
      this.label15.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label15.Location = new System.Drawing.Point(336, 68);
      this.label15.Name = "label15";
      this.label15.Size = new System.Drawing.Size(116, 20);
      this.label15.TabIndex = 9;
      this.label15.Text = "Status/Description";
      // 
      // txtLogSeconds
      // 
      this.txtLogSeconds.Location = new System.Drawing.Point(408, 40);
      this.txtLogSeconds.Name = "txtLogSeconds";
      this.txtLogSeconds.Size = new System.Drawing.Size(120, 20);
      this.txtLogSeconds.TabIndex = 6;
      // 
      // label14
      // 
      this.label14.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label14.Location = new System.Drawing.Point(336, 40);
      this.label14.Name = "label14";
      this.label14.Size = new System.Drawing.Size(80, 20);
      this.label14.TabIndex = 6;
      this.label14.Text = "Log Seconds:";
      // 
      // panAllocationEntity
      // 
      this.panAllocationEntity.Controls.Add(this.label13);
      this.panAllocationEntity.Controls.Add(this.txtAllocationEntityID);
      this.panAllocationEntity.Controls.Add(this.cmdSetAllocationEntity);
      this.panAllocationEntity.Location = new System.Drawing.Point(8, 184);
      this.panAllocationEntity.Name = "panAllocationEntity";
      this.panAllocationEntity.Size = new System.Drawing.Size(320, 24);
      this.panAllocationEntity.TabIndex = 5;
      this.panAllocationEntity.Visible = false;
      // 
      // label13
      // 
      this.label13.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label13.Location = new System.Drawing.Point(4, 4);
      this.label13.Name = "label13";
      this.label13.Size = new System.Drawing.Size(116, 16);
      this.label13.TabIndex = 8;
      this.label13.Text = "Bottom-most Entity ID";
      // 
      // txtAllocationEntityID
      // 
      this.txtAllocationEntityID.Location = new System.Drawing.Point(124, 0);
      this.txtAllocationEntityID.Name = "txtAllocationEntityID";
      this.txtAllocationEntityID.Size = new System.Drawing.Size(140, 20);
      this.txtAllocationEntityID.TabIndex = 3;
      // 
      // cmdSetAllocationEntity
      // 
      this.cmdSetAllocationEntity.Location = new System.Drawing.Point(268, 0);
      this.cmdSetAllocationEntity.Name = "cmdSetAllocationEntity";
      this.cmdSetAllocationEntity.Size = new System.Drawing.Size(48, 20);
      this.cmdSetAllocationEntity.TabIndex = 4;
      this.cmdSetAllocationEntity.Text = "Set";
      this.cmdSetAllocationEntity.Click += new System.EventHandler(this.cmdSetAllocationEntity_Click);
      // 
      // lstAllocationEntityTypes
      // 
      this.lstAllocationEntityTypes.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.lstAllocationEntityTypes.ItemHeight = 14;
      this.lstAllocationEntityTypes.Location = new System.Drawing.Point(8, 36);
      this.lstAllocationEntityTypes.Name = "lstAllocationEntityTypes";
      this.lstAllocationEntityTypes.Size = new System.Drawing.Size(320, 144);
      this.lstAllocationEntityTypes.TabIndex = 2;
      this.lstAllocationEntityTypes.SelectedIndexChanged += new System.EventHandler(this.lstAllocationEntityTypes_SelectedIndexChanged);
      // 
      // cmdPrepareCreateTimeLog
      // 
      this.cmdPrepareCreateTimeLog.Location = new System.Drawing.Point(8, 8);
      this.cmdPrepareCreateTimeLog.Name = "cmdPrepareCreateTimeLog";
      this.cmdPrepareCreateTimeLog.Size = new System.Drawing.Size(156, 24);
      this.cmdPrepareCreateTimeLog.TabIndex = 1;
      this.cmdPrepareCreateTimeLog.Text = "Prepare to Create Time Log";
      this.cmdPrepareCreateTimeLog.Click += new System.EventHandler(this.cmdPrepareCreateTimeLog_Click);
      // 
      // tabPage4
      // 
      this.tabPage4.Controls.Add(this.txtTimeLogID);
      this.tabPage4.Controls.Add(this.cmdClearTimeLogBilled);
      this.tabPage4.Controls.Add(this.cmdSetTimeLogBilled);
      this.tabPage4.Controls.Add(this.cmdGetTimeLogBilled);
      this.tabPage4.Controls.Add(this.label21);
      this.tabPage4.Controls.Add(this.dateGetTimeLogsTo);
      this.tabPage4.Controls.Add(this.dateGetTimeLogsFrom);
      this.tabPage4.Controls.Add(this.label18);
      this.tabPage4.Controls.Add(this.label17);
      this.tabPage4.Controls.Add(this.cmdGetTimeLogs);
      this.tabPage4.Controls.Add(this.gridTimeLogs);
      this.tabPage4.Location = new System.Drawing.Point(4, 23);
      this.tabPage4.Name = "tabPage4";
      this.tabPage4.Size = new System.Drawing.Size(544, 209);
      this.tabPage4.TabIndex = 3;
      this.tabPage4.Text = "GetTimeLogs";
      this.tabPage4.UseVisualStyleBackColor = true;
      // 
      // txtTimeLogID
      // 
      this.txtTimeLogID.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.txtTimeLogID.Location = new System.Drawing.Point(496, 28);
      this.txtTimeLogID.Name = "txtTimeLogID";
      this.txtTimeLogID.Size = new System.Drawing.Size(44, 20);
      this.txtTimeLogID.TabIndex = 10;
      this.txtTimeLogID.Visible = false;
      // 
      // cmdClearTimeLogBilled
      // 
      this.cmdClearTimeLogBilled.Enabled = false;
      this.cmdClearTimeLogBilled.Location = new System.Drawing.Point(452, 24);
      this.cmdClearTimeLogBilled.Name = "cmdClearTimeLogBilled";
      this.cmdClearTimeLogBilled.Size = new System.Drawing.Size(40, 24);
      this.cmdClearTimeLogBilled.TabIndex = 9;
      this.cmdClearTimeLogBilled.Text = "Clear";
      this.cmdClearTimeLogBilled.Click += new System.EventHandler(this.cmdClearTimeLogBilled_Click);
      // 
      // cmdSetTimeLogBilled
      // 
      this.cmdSetTimeLogBilled.Enabled = false;
      this.cmdSetTimeLogBilled.Location = new System.Drawing.Point(408, 24);
      this.cmdSetTimeLogBilled.Name = "cmdSetTimeLogBilled";
      this.cmdSetTimeLogBilled.Size = new System.Drawing.Size(40, 24);
      this.cmdSetTimeLogBilled.TabIndex = 8;
      this.cmdSetTimeLogBilled.Text = "Set";
      this.cmdSetTimeLogBilled.Click += new System.EventHandler(this.cmdSetTimeLogBilled_Click);
      // 
      // cmdGetTimeLogBilled
      // 
      this.cmdGetTimeLogBilled.Enabled = false;
      this.cmdGetTimeLogBilled.Location = new System.Drawing.Point(364, 24);
      this.cmdGetTimeLogBilled.Name = "cmdGetTimeLogBilled";
      this.cmdGetTimeLogBilled.Size = new System.Drawing.Size(40, 24);
      this.cmdGetTimeLogBilled.TabIndex = 7;
      this.cmdGetTimeLogBilled.Text = "Get";
      this.cmdGetTimeLogBilled.Click += new System.EventHandler(this.cmdGetTimeLogBilled_Click);
      // 
      // label21
      // 
      this.label21.Location = new System.Drawing.Point(364, 4);
      this.label21.Name = "label21";
      this.label21.Size = new System.Drawing.Size(164, 16);
      this.label21.TabIndex = 6;
      this.label21.Text = "Billing status of selected log:";
      // 
      // dateGetTimeLogsTo
      // 
      this.dateGetTimeLogsTo.Location = new System.Drawing.Point(44, 28);
      this.dateGetTimeLogsTo.Name = "dateGetTimeLogsTo";
      this.dateGetTimeLogsTo.Size = new System.Drawing.Size(188, 20);
      this.dateGetTimeLogsTo.TabIndex = 5;
      this.dateGetTimeLogsTo.Value = new System.DateTime(2007, 4, 3, 0, 0, 0, 0);
      // 
      // dateGetTimeLogsFrom
      // 
      this.dateGetTimeLogsFrom.Location = new System.Drawing.Point(44, 8);
      this.dateGetTimeLogsFrom.Name = "dateGetTimeLogsFrom";
      this.dateGetTimeLogsFrom.Size = new System.Drawing.Size(188, 20);
      this.dateGetTimeLogsFrom.TabIndex = 4;
      this.dateGetTimeLogsFrom.Value = new System.DateTime(2007, 4, 3, 0, 0, 0, 0);
      // 
      // label18
      // 
      this.label18.Location = new System.Drawing.Point(8, 32);
      this.label18.Name = "label18";
      this.label18.Size = new System.Drawing.Size(24, 16);
      this.label18.TabIndex = 3;
      this.label18.Text = "To:";
      // 
      // label17
      // 
      this.label17.Location = new System.Drawing.Point(8, 12);
      this.label17.Name = "label17";
      this.label17.Size = new System.Drawing.Size(36, 16);
      this.label17.TabIndex = 2;
      this.label17.Text = "From:";
      // 
      // cmdGetTimeLogs
      // 
      this.cmdGetTimeLogs.Location = new System.Drawing.Point(236, 24);
      this.cmdGetTimeLogs.Name = "cmdGetTimeLogs";
      this.cmdGetTimeLogs.Size = new System.Drawing.Size(88, 24);
      this.cmdGetTimeLogs.TabIndex = 1;
      this.cmdGetTimeLogs.Text = "GetTimeLogs";
      this.cmdGetTimeLogs.Click += new System.EventHandler(this.cmdGetTimeLogs_Click);
      // 
      // gridTimeLogs
      // 
      this.gridTimeLogs.CaptionVisible = false;
      this.gridTimeLogs.DataMember = "";
      this.gridTimeLogs.HeaderForeColor = System.Drawing.SystemColors.ControlText;
      this.gridTimeLogs.Location = new System.Drawing.Point(8, 52);
      this.gridTimeLogs.Name = "gridTimeLogs";
      this.gridTimeLogs.ReadOnly = true;
      this.gridTimeLogs.RowHeadersVisible = false;
      this.gridTimeLogs.Size = new System.Drawing.Size(532, 152);
      this.gridTimeLogs.TabIndex = 0;
      this.gridTimeLogs.CurrentCellChanged += new System.EventHandler(this.gridTimeLogs_CurrentCellChanged);
      // 
      // tabPage5
      // 
      this.tabPage5.Controls.Add(this.cmdGetCustomFieldValuesEntity);
      this.tabPage5.Controls.Add(this.gridCustomFieldValues);
      this.tabPage5.Controls.Add(this.label20);
      this.tabPage5.Controls.Add(this.txtCustomFieldEntityID);
      this.tabPage5.Location = new System.Drawing.Point(4, 23);
      this.tabPage5.Name = "tabPage5";
      this.tabPage5.Size = new System.Drawing.Size(544, 209);
      this.tabPage5.TabIndex = 4;
      this.tabPage5.Text = "CustomFieldValues";
      this.tabPage5.UseVisualStyleBackColor = true;
      // 
      // cmdGetCustomFieldValuesEntity
      // 
      this.cmdGetCustomFieldValuesEntity.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.cmdGetCustomFieldValuesEntity.Location = new System.Drawing.Point(4, 53);
      this.cmdGetCustomFieldValuesEntity.Name = "cmdGetCustomFieldValuesEntity";
      this.cmdGetCustomFieldValuesEntity.Size = new System.Drawing.Size(104, 24);
      this.cmdGetCustomFieldValuesEntity.TabIndex = 27;
      this.cmdGetCustomFieldValuesEntity.Text = "Get Values";
      this.cmdGetCustomFieldValuesEntity.Click += new System.EventHandler(this.cmdGetCustomFieldValuesEntity_Click);
      // 
      // gridCustomFieldValues
      // 
      this.gridCustomFieldValues.CaptionVisible = false;
      this.gridCustomFieldValues.DataMember = "";
      this.gridCustomFieldValues.HeaderForeColor = System.Drawing.SystemColors.ControlText;
      this.gridCustomFieldValues.Location = new System.Drawing.Point(114, 4);
      this.gridCustomFieldValues.Name = "gridCustomFieldValues";
      this.gridCustomFieldValues.ReadOnly = true;
      this.gridCustomFieldValues.RowHeadersVisible = false;
      this.gridCustomFieldValues.Size = new System.Drawing.Size(426, 200);
      this.gridCustomFieldValues.TabIndex = 26;
      // 
      // label20
      // 
      this.label20.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label20.Location = new System.Drawing.Point(2, 6);
      this.label20.Name = "label20";
      this.label20.Size = new System.Drawing.Size(104, 20);
      this.label20.TabIndex = 25;
      this.label20.Text = "EntityID:";
      // 
      // txtCustomFieldEntityID
      // 
      this.txtCustomFieldEntityID.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.txtCustomFieldEntityID.Location = new System.Drawing.Point(4, 29);
      this.txtCustomFieldEntityID.Name = "txtCustomFieldEntityID";
      this.txtCustomFieldEntityID.Size = new System.Drawing.Size(104, 20);
      this.txtCustomFieldEntityID.TabIndex = 23;
      // 
      // tabPage6
      // 
      this.tabPage6.Controls.Add(this.txtMetricsSPI);
      this.tabPage6.Controls.Add(this.label26);
      this.tabPage6.Controls.Add(this.txtMetricsCPI);
      this.tabPage6.Controls.Add(this.label25);
      this.tabPage6.Controls.Add(this.txtMetricsTotalSecs);
      this.tabPage6.Controls.Add(this.label24);
      this.tabPage6.Controls.Add(this.txtMetricsAsOf);
      this.tabPage6.Controls.Add(this.label23);
      this.tabPage6.Controls.Add(this.txtGetEntityMetrics);
      this.tabPage6.Controls.Add(this.label22);
      this.tabPage6.Controls.Add(this.txtMetricsEntityID);
      this.tabPage6.Location = new System.Drawing.Point(4, 23);
      this.tabPage6.Name = "tabPage6";
      this.tabPage6.Size = new System.Drawing.Size(544, 209);
      this.tabPage6.TabIndex = 5;
      this.tabPage6.Text = "EntityMetrics";
      this.tabPage6.UseVisualStyleBackColor = true;
      // 
      // txtMetricsSPI
      // 
      this.txtMetricsSPI.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.txtMetricsSPI.Location = new System.Drawing.Point(312, 72);
      this.txtMetricsSPI.Name = "txtMetricsSPI";
      this.txtMetricsSPI.Size = new System.Drawing.Size(104, 20);
      this.txtMetricsSPI.TabIndex = 38;
      // 
      // label26
      // 
      this.label26.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label26.Location = new System.Drawing.Point(196, 72);
      this.label26.Name = "label26";
      this.label26.Size = new System.Drawing.Size(104, 20);
      this.label26.TabIndex = 37;
      this.label26.Text = "SPI:";
      // 
      // txtMetricsCPI
      // 
      this.txtMetricsCPI.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.txtMetricsCPI.Location = new System.Drawing.Point(312, 52);
      this.txtMetricsCPI.Name = "txtMetricsCPI";
      this.txtMetricsCPI.Size = new System.Drawing.Size(104, 20);
      this.txtMetricsCPI.TabIndex = 36;
      // 
      // label25
      // 
      this.label25.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label25.Location = new System.Drawing.Point(196, 52);
      this.label25.Name = "label25";
      this.label25.Size = new System.Drawing.Size(104, 20);
      this.label25.TabIndex = 35;
      this.label25.Text = "CPI:";
      // 
      // txtMetricsTotalSecs
      // 
      this.txtMetricsTotalSecs.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.txtMetricsTotalSecs.Location = new System.Drawing.Point(312, 32);
      this.txtMetricsTotalSecs.Name = "txtMetricsTotalSecs";
      this.txtMetricsTotalSecs.Size = new System.Drawing.Size(104, 20);
      this.txtMetricsTotalSecs.TabIndex = 34;
      // 
      // label24
      // 
      this.label24.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label24.Location = new System.Drawing.Point(196, 32);
      this.label24.Name = "label24";
      this.label24.Size = new System.Drawing.Size(104, 20);
      this.label24.TabIndex = 33;
      this.label24.Text = "Total seconds:";
      // 
      // txtMetricsAsOf
      // 
      this.txtMetricsAsOf.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.txtMetricsAsOf.Location = new System.Drawing.Point(312, 12);
      this.txtMetricsAsOf.Name = "txtMetricsAsOf";
      this.txtMetricsAsOf.Size = new System.Drawing.Size(104, 20);
      this.txtMetricsAsOf.TabIndex = 32;
      // 
      // label23
      // 
      this.label23.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label23.Location = new System.Drawing.Point(196, 12);
      this.label23.Name = "label23";
      this.label23.Size = new System.Drawing.Size(104, 20);
      this.label23.TabIndex = 31;
      this.label23.Text = "As of:";
      // 
      // txtGetEntityMetrics
      // 
      this.txtGetEntityMetrics.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.txtGetEntityMetrics.Location = new System.Drawing.Point(8, 56);
      this.txtGetEntityMetrics.Name = "txtGetEntityMetrics";
      this.txtGetEntityMetrics.Size = new System.Drawing.Size(104, 24);
      this.txtGetEntityMetrics.TabIndex = 30;
      this.txtGetEntityMetrics.Text = "GetEntityMetrics";
      this.txtGetEntityMetrics.Click += new System.EventHandler(this.GetEntityMetrics_Click);
      // 
      // label22
      // 
      this.label22.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label22.Location = new System.Drawing.Point(8, 12);
      this.label22.Name = "label22";
      this.label22.Size = new System.Drawing.Size(104, 20);
      this.label22.TabIndex = 29;
      this.label22.Text = "EntityID:";
      // 
      // txtMetricsEntityID
      // 
      this.txtMetricsEntityID.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.txtMetricsEntityID.Location = new System.Drawing.Point(8, 32);
      this.txtMetricsEntityID.Name = "txtMetricsEntityID";
      this.txtMetricsEntityID.Size = new System.Drawing.Size(104, 20);
      this.txtMetricsEntityID.TabIndex = 28;
      // 
      // tabPage7
      // 
      this.tabPage7.Controls.Add(this.gridFindEntities);
      this.tabPage7.Controls.Add(this.txtFindEntityName);
      this.tabPage7.Controls.Add(this.label27);
      this.tabPage7.Location = new System.Drawing.Point(4, 23);
      this.tabPage7.Name = "tabPage7";
      this.tabPage7.Size = new System.Drawing.Size(544, 209);
      this.tabPage7.TabIndex = 6;
      this.tabPage7.Text = "FindEntities";
      this.tabPage7.UseVisualStyleBackColor = true;
      // 
      // gridFindEntities
      // 
      this.gridFindEntities.CaptionVisible = false;
      this.gridFindEntities.DataMember = "";
      this.gridFindEntities.HeaderForeColor = System.Drawing.SystemColors.ControlText;
      this.gridFindEntities.Location = new System.Drawing.Point(8, 32);
      this.gridFindEntities.Name = "gridFindEntities";
      this.gridFindEntities.ReadOnly = true;
      this.gridFindEntities.RowHeadersVisible = false;
      this.gridFindEntities.Size = new System.Drawing.Size(532, 168);
      this.gridFindEntities.TabIndex = 27;
      // 
      // txtFindEntityName
      // 
      this.txtFindEntityName.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.txtFindEntityName.Location = new System.Drawing.Point(80, 8);
      this.txtFindEntityName.Name = "txtFindEntityName";
      this.txtFindEntityName.Size = new System.Drawing.Size(160, 20);
      this.txtFindEntityName.TabIndex = 13;
      this.txtFindEntityName.TextChanged += new System.EventHandler(this.txtFindEntityName_TextChanged);
      // 
      // label27
      // 
      this.label27.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label27.Location = new System.Drawing.Point(8, 12);
      this.label27.Name = "label27";
      this.label27.Size = new System.Drawing.Size(72, 20);
      this.label27.TabIndex = 12;
      this.label27.Text = "Entity Name";
      // 
      // tabPage8
      // 
      this.tabPage8.Controls.Add(this.cmdAssign);
      this.tabPage8.Controls.Add(this.cmbRoleTypes);
      this.tabPage8.Controls.Add(this.label29);
      this.tabPage8.Controls.Add(this.cmdGetRoleTypeList);
      this.tabPage8.Controls.Add(this.txtAssignToEntityID);
      this.tabPage8.Controls.Add(this.label28);
      this.tabPage8.Controls.Add(this.txtAssignFromEntityID);
      this.tabPage8.Controls.Add(this.label19);
      this.tabPage8.Location = new System.Drawing.Point(4, 23);
      this.tabPage8.Name = "tabPage8";
      this.tabPage8.Size = new System.Drawing.Size(544, 209);
      this.tabPage8.TabIndex = 7;
      this.tabPage8.Text = "Assignment";
      this.tabPage8.UseVisualStyleBackColor = true;
      // 
      // cmdAssign
      // 
      this.cmdAssign.Location = new System.Drawing.Point(177, 113);
      this.cmdAssign.Name = "cmdAssign";
      this.cmdAssign.Size = new System.Drawing.Size(156, 24);
      this.cmdAssign.TabIndex = 26;
      this.cmdAssign.Text = "Assign";
      this.cmdAssign.Click += new System.EventHandler(this.cmdAssign_Click);
      // 
      // cmbRoleTypes
      // 
      this.cmbRoleTypes.Location = new System.Drawing.Point(176, 72);
      this.cmbRoleTypes.Name = "cmbRoleTypes";
      this.cmbRoleTypes.Size = new System.Drawing.Size(157, 22);
      this.cmbRoleTypes.TabIndex = 24;
      // 
      // label29
      // 
      this.label29.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label29.Location = new System.Drawing.Point(173, 55);
      this.label29.Name = "label29";
      this.label29.Size = new System.Drawing.Size(160, 14);
      this.label29.TabIndex = 27;
      this.label29.Text = "In Role";
      // 
      // cmdGetRoleTypeList
      // 
      this.cmdGetRoleTypeList.Location = new System.Drawing.Point(176, 21);
      this.cmdGetRoleTypeList.Name = "cmdGetRoleTypeList";
      this.cmdGetRoleTypeList.Size = new System.Drawing.Size(156, 24);
      this.cmdGetRoleTypeList.TabIndex = 22;
      this.cmdGetRoleTypeList.Text = "GetRoleTypeList";
      this.cmdGetRoleTypeList.Click += new System.EventHandler(this.cmdGetRoleTypeList_Click);
      // 
      // txtAssignToEntityID
      // 
      this.txtAssignToEntityID.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.txtAssignToEntityID.Location = new System.Drawing.Point(356, 74);
      this.txtAssignToEntityID.Name = "txtAssignToEntityID";
      this.txtAssignToEntityID.Size = new System.Drawing.Size(108, 20);
      this.txtAssignToEntityID.TabIndex = 25;
      // 
      // label28
      // 
      this.label28.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label28.Location = new System.Drawing.Point(353, 55);
      this.label28.Name = "label28";
      this.label28.Size = new System.Drawing.Size(92, 14);
      this.label28.TabIndex = 25;
      this.label28.Text = "To EntityID";
      // 
      // txtAssignFromEntityID
      // 
      this.txtAssignFromEntityID.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.txtAssignFromEntityID.Location = new System.Drawing.Point(20, 74);
      this.txtAssignFromEntityID.Name = "txtAssignFromEntityID";
      this.txtAssignFromEntityID.Size = new System.Drawing.Size(108, 20);
      this.txtAssignFromEntityID.TabIndex = 23;
      // 
      // label19
      // 
      this.label19.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label19.Location = new System.Drawing.Point(17, 55);
      this.label19.Name = "label19";
      this.label19.Size = new System.Drawing.Size(160, 14);
      this.label19.TabIndex = 23;
      this.label19.Text = "Assign User or Group EntityID";
      // 
      // label10
      // 
      this.label10.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.label10.Location = new System.Drawing.Point(8, 8);
      this.label10.Name = "label10";
      this.label10.Size = new System.Drawing.Size(28, 20);
      this.label10.TabIndex = 0;
      this.label10.Text = "URL";
      // 
      // txtURL
      // 
      this.txtURL.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.txtURL.Location = new System.Drawing.Point(36, 8);
      this.txtURL.Name = "txtURL";
      this.txtURL.Size = new System.Drawing.Size(132, 20);
      this.txtURL.TabIndex = 1;
      this.txtURL.Text = "http://vegas:81/sample";
      // 
      // cmdTouch
      // 
      this.cmdTouch.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
      this.cmdTouch.Location = new System.Drawing.Point(444, 8);
      this.cmdTouch.Name = "cmdTouch";
      this.cmdTouch.Size = new System.Drawing.Size(53, 24);
      this.cmdTouch.TabIndex = 21;
      this.cmdTouch.Text = "Touch";
      this.cmdTouch.Click += new System.EventHandler(this.cmdTouch_Click);
      // 
      // frmMain
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(560, 518);
      this.Controls.Add(this.cmdTouch);
      this.Controls.Add(this.label10);
      this.Controls.Add(this.txtURL);
      this.Controls.Add(this.txtPassword);
      this.Controls.Add(this.txtUserName);
      this.Controls.Add(this.txtSessionID);
      this.Controls.Add(this.txtLanguageCodeIn);
      this.Controls.Add(this.txtAPIVersion);
      this.Controls.Add(this.tabsMain);
      this.Controls.Add(this.label9);
      this.Controls.Add(this.label7);
      this.Controls.Add(this.label8);
      this.Controls.Add(this.cmdGoodbye);
      this.Controls.Add(this.cmdLoginStandard);
      this.Controls.Add(this.cmdLoginWindows);
      this.Controls.Add(this.label6);
      this.Controls.Add(this.label4);
      this.Controls.Add(this.label3);
      this.Controls.Add(this.lstResults);
      this.Controls.Add(this.label5);
      this.Controls.Add(this.label2);
      this.Controls.Add(this.label1);
      this.Controls.Add(this.cmdHello);
      this.Name = "frmMain";
      this.Text = "TimeTiger API Sample";
      this.Load += new System.EventHandler(this.Form1_Load);
      this.tabsMain.ResumeLayout(false);
      this.tabPage1.ResumeLayout(false);
      this.tabPage2.ResumeLayout(false);
      this.tabPage2.PerformLayout();
      this.panCreateEntity.ResumeLayout(false);
      this.panCreateEntity.PerformLayout();
      this.tabPage3.ResumeLayout(false);
      this.tabPage3.PerformLayout();
      this.panAllocationEntity.ResumeLayout(false);
      this.panAllocationEntity.PerformLayout();
      this.tabPage4.ResumeLayout(false);
      this.tabPage4.PerformLayout();
      ((System.ComponentModel.ISupportInitialize)(this.gridTimeLogs)).EndInit();
      this.tabPage5.ResumeLayout(false);
      this.tabPage5.PerformLayout();
      ((System.ComponentModel.ISupportInitialize)(this.gridCustomFieldValues)).EndInit();
      this.tabPage6.ResumeLayout(false);
      this.tabPage6.PerformLayout();
      this.tabPage7.ResumeLayout(false);
      this.tabPage7.PerformLayout();
      ((System.ComponentModel.ISupportInitialize)(this.gridFindEntities)).EndInit();
      this.tabPage8.ResumeLayout(false);
      this.tabPage8.PerformLayout();
      this.ResumeLayout(false);
      this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			dateGetTimeLogsTo.Value = DateTime.Today;
			dateGetTimeLogsFrom.Value = DateTime.Today.Subtract(new System.TimeSpan(14,0,0,0,0));
		}

		private void cmdHello_Click(object sender, System.EventArgs e)
		{
			ttsystem.ttsystem TTServer = new ttsystem.ttsystem();
			TTServer.Url = txtURL.Text + "/ttxml";
			ttsystem.HelloOutput outHello = TTServer.Hello(txtAPIVersion.Text, txtLanguageCodeIn.Text);
			txtSessionID.Text = outHello.SessionID;
			AddResult("Hello", outHello.Message + "(" + outHello.ResultCode + ")" + ", using language code " + outHello.LanguageCode);
		}

		public void AddResult(string sMethod, string sResult)
		{
			lstResults.Items.Add(sMethod + ": " + sResult);
			lstResults.SelectedIndex = lstResults.Items.Count - 1;
		}

		private void cmdGoodbye_Click(object sender, System.EventArgs e)
		{
			ttsystem.ttsystem TTServer = new ttsystem.ttsystem();
			TTServer.Url = txtURL.Text + "/ttxml";
			ttsystem.GoodbyeOutput outGoodbye = TTServer.Goodbye(txtSessionID.Text);
			AddResult("Goodbye", outGoodbye.Message + "(" + outGoodbye.ResultCode + ")");

			// Clear the session ID if our Goodbye is successful

			if (System.Convert.ToInt32(outGoodbye.ResultCode) >= 0) 
				txtSessionID.Text = "";
		}

		private void cmdLoginStandard_Click(object sender, System.EventArgs e)
		{
			ttsystem.ttsystem TTServer = new ttsystem.ttsystem();
			TTServer.Url = txtURL.Text + "/ttxml";
			ttsystem.LoginStandardOutput outLogin = TTServer.LoginStandard(txtSessionID.Text, txtUserName.Text, txtPassword.Text);
			AddResult("LoginStandard", outLogin.Message + "(" + outLogin.ResultCode + ")");

			// Say Hello if our Login is successful

			if (System.Convert.ToInt32(outLogin.ResultCode) >= 0) 
				AddResult("Welcome to TimeTiger", outLogin.UserName + " (UserID = " + outLogin.UserID + ")");
		}

		private void cmdLoginWindows_Click(object sender, System.EventArgs e)
		{
			ttsystem.ttsystem TTServer = new ttsystem.ttsystem();
			TTServer.Url = txtURL.Text + "/ttxml";

			// Use the current user's credentials for Windows authentication

			TTServer.Credentials = System.Net.CredentialCache.DefaultCredentials;
			ttsystem.LoginWindowsOutput outLogin = TTServer.LoginWindows(txtSessionID.Text);
			AddResult("LoginWindows", outLogin.Message + "(" + outLogin.ResultCode + ")");

			// Say Hello if our Login is successful

			if (System.Convert.ToInt32(outLogin.ResultCode) >= 0) 
				AddResult("Welcome to TimeTiger", outLogin.UserName + " (UserID = " + outLogin.UserID + ")");
		}

		private void cmdGetEntityTypeList_Click(object sender, System.EventArgs e)
		{
			ttsystem.ttsystem TTServer = new ttsystem.ttsystem();
			TTServer.Url = txtURL.Text + "/ttxml";
			string sBottomMost = "0";
			if (chkGetEntityTypesBottomMost.Checked)
				sBottomMost = "1";

			ttsystem.GetEntityTypeListOutput outGetEntityTypeList = TTServer.GetEntityTypeList(txtSessionID.Text, sBottomMost);
			AddResult("GetEntityTypeList", outGetEntityTypeList.Message + "(" + outGetEntityTypeList.ResultCode + ")");
			if (System.Convert.ToInt32(outGetEntityTypeList.ResultCode) < 0) 
				return;

			// Add the types to our listbox

			lstEntityTypes.Items.Clear();
			
			for (int i = 0; i < outGetEntityTypeList.EntityTypes.Length; i++)
			{
				string sItem = outGetEntityTypeList.EntityTypes[i].EntityTypeCaptions[0].Description + " (UID = " + outGetEntityTypeList.EntityTypes[i].UID + ")";
				lstEntityTypes.Items.Add(sItem);
			}
		}

		private void cmdGetEntities_Click(object sender, System.EventArgs e)
		{
			// Clear the current list

			treeEntities.Nodes.Clear();
			panCreateEntity.Visible = false;

			// We're going to be adding to the root node

			System.Windows.Forms.TreeNodeCollection nodesAdd = treeEntities.Nodes;

			// Issue the request

			PopulateEntityLevel(nodesAdd, "");
		}

		private void cmdClearEntities_Click(object sender, System.EventArgs e)
		{
			treeEntities.Nodes.Clear();
			panCreateEntity.Visible = false;
		}

		private void PopulateEntityLevel(System.Windows.Forms.TreeNodeCollection nodesAdd, string sParentID)
		{
			// Get the collection of child nodes

			ttsystem.ttsystem TTServer = new ttsystem.ttsystem();
			TTServer.Url = txtURL.Text + "/ttxml";
			ttsystem.GetEntitiesOutput outGetEntities = TTServer.GetEntities(txtSessionID.Text, sParentID, "0", "0", "0");
			AddResult("GetEntities", outGetEntities.Message + "(" + outGetEntities.ResultCode + ")");
			if (System.Convert.ToInt32(outGetEntities.ResultCode) < 0) 
				return;

			nodesAdd.Clear();
			for (int i = 0; i < outGetEntities.EntityNodes.Length; i++)
			{
				string sItem = outGetEntities.EntityNodes[i].EntityName + " (" + outGetEntities.EntityNodes[i].EntityTypeName + ")";

				TreeNode theNode = new TreeNode(sItem);
				theNode.Tag = outGetEntities.EntityNodes[i].UID;
				nodesAdd.Add(theNode);

				// Do we need to add a placeholder below this node
				// so that the tree control adds an expansion + icon?

				if (outGetEntities.EntityNodes[i].ChildCount != "0") 
					theNode.Nodes.Add(new TreeNode("Placeholder"));
			}
		}

		private void treeEntities_BeforeExpand(object sender, System.Windows.Forms.TreeViewCancelEventArgs e)
		{
			PopulateEntityLevel(e.Node.Nodes, e.Node.Tag.ToString());
		}

		private void treeEntities_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			RefreshCreatePanel();
		}

		private void RefreshCreatePanel()
		{
			// Get the EntityID of the selected node, or exit

			string sSubjectID;
			try
			{
				sSubjectID = treeEntities.SelectedNode.Tag.ToString();
				txtSelectedEntityID.Text = sSubjectID;
			}
			catch
			{
				panCreateEntity.Visible = false;
				return;
			}

			// Refresh the list of available child entity types

			ttsystem.ttsystem TTServer = new ttsystem.ttsystem();
			TTServer.Url = txtURL.Text + "/ttxml";
			ttsystem.GetValidChildTypesOutput outGetValidChildTypes = TTServer.GetValidChildTypes(txtSessionID.Text, sSubjectID);
			AddResult("GetValidChildTypes", outGetValidChildTypes.Message + "(" + outGetValidChildTypes.ResultCode + ")");
			if (System.Convert.ToInt32(outGetValidChildTypes.ResultCode) < 0) 
				return;

			// Add the types to our listbox

			cmbCreateEntityType.Items.Clear();
			cmbCreateEntityType.Text = "";
			for (int i = 0; i < outGetValidChildTypes.EntityTypes.Length; i++)
			{
				UniqueString theItem = new UniqueString(outGetValidChildTypes.EntityTypes[i].Value);
				theItem.ID =  outGetValidChildTypes.EntityTypes[i].ID;
				cmbCreateEntityType.Items.Add(theItem);
			}

			// If there are no avaiable child types to add, hide the panel

			if (cmbCreateEntityType.Items.Count == 0)
			{
				panCreateEntity.Visible = false;
				return;
			}

			// Select the last entity type

			cmbCreateEntityType.SelectedIndex = outGetValidChildTypes.EntityTypes.Length - 1;

			// Can we add children?

			if (outGetValidChildTypes.CanAdd == "1")
				cmdCreateEntity.Enabled = true;
			else
				cmdCreateEntity.Enabled = false;

			// Show the panel

			panCreateEntity.Visible = true;
		}

		private void cmbCreateEntityType_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			string sItem = "";
			try
			{
				UniqueString s = (UniqueString)cmbCreateEntityType.Items[cmbCreateEntityType.SelectedIndex];
				sItem = "New " + s.Value;
			}
			catch
			{
			}
			txtCreateEntityName.Text = sItem;
		}

		private void cmdCreateEntity_Click(object sender, System.EventArgs e)
		{
			string sEntityName = txtCreateEntityName.Text;
			string sEntityTypeID = ((UniqueString)(cmbCreateEntityType.SelectedItem)).ID;
			string sParentEntityID = "";

			// If this is not a top-level node, set the ParentEntityID
			// For top-level nodes sParentEntityID should be blank

			if (treeEntities.SelectedNode.Parent != null)
				sParentEntityID = treeEntities.SelectedNode.Tag.ToString();

			// Attempt to create the entity

			ttsystem.ttsystem TTServer = new ttsystem.ttsystem();
			TTServer.Url = txtURL.Text + "/ttxml";
			ttsystem.StringPair[] aCustomFieldValues = new ttsystem.StringPair[1]; // leave blank
			ttsystem.DefaultPick[] aDefaultPicks = new ttsystem.DefaultPick[1]; // populate with a DefaultPick structure if desired

			ttsystem.CreateEntityOutput outCreateEntity = TTServer.CreateEntity(txtSessionID.Text, sEntityTypeID, sParentEntityID, txtCreateEntityName.Text, aCustomFieldValues, aDefaultPicks);
			AddResult("CreateEntity", outCreateEntity.Message + "(" + outCreateEntity.ResultCode + ")");
			if (System.Convert.ToInt32(outCreateEntity.ResultCode) < 0) 
				return;

			// Success. Update the children of the current node

			PopulateEntityLevel(treeEntities.SelectedNode.Nodes, treeEntities.SelectedNode.Tag.ToString());
		}

		private void cmdTouch_Click(object sender, System.EventArgs e)
		{
			ttsystem.ttsystem TTServer = new ttsystem.ttsystem();
			TTServer.Url = txtURL.Text + "/ttxml";
			ttsystem.TouchOutput outTouch = TTServer.Touch(txtSessionID.Text);
			AddResult("Touch", outTouch.Message + "(" + outTouch.ResultCode + ")");
		}

		private void cmdPrepareCreateTimeLog_Click(object sender, System.EventArgs e)
		{
			// Clear fields

			txtLogDate.Text = DateTime.Now.ToShortDateString();
			txtLogSeconds.Text = "";
			txtStatusDescription.Text = "";
			
			// Get the bottom-most entity types (these are the ones our log will be allocated to)

			ttsystem.ttsystem TTServer = new ttsystem.ttsystem();
			TTServer.Url = txtURL.Text + "/ttxml";
			ttsystem.GetEntityTypeListOutput outGetEntityTypeList = TTServer.GetEntityTypeList(txtSessionID.Text, "1");
			AddResult("GetEntityTypeList", outGetEntityTypeList.Message + "(" + outGetEntityTypeList.ResultCode + ")");
			if (System.Convert.ToInt32(outGetEntityTypeList.ResultCode) < 0) 
				return;

			// Add the types to our listbox

			lstAllocationEntityTypes.Items.Clear();
			
			for (int i = 0; i < outGetEntityTypeList.EntityTypes.Length; i++)
			{
				string sItem = outGetEntityTypeList.EntityTypes[i].EntityTypeCaptions[0].Description + " (UID " + outGetEntityTypeList.EntityTypes[i].UID + ") = ";
				lstAllocationEntityTypes.Items.Add(sItem);
			}

			// Hide the entity setting panel

			RefreshAllocationEntity();
		}

		private void lstAllocationEntityTypes_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			RefreshAllocationEntity();
		}

		private void RefreshAllocationEntity()
		{
			if (lstAllocationEntityTypes.SelectedItem == null)
				panAllocationEntity.Visible = false;
			else
			{
				// Parse out the ID of the selected item, if any

				txtAllocationEntityID.Text = "";
				string sSelectedRowText = lstAllocationEntityTypes.SelectedItem.ToString();

				// If we've assigned an entity ID to this Entity Type, show it

				if (sSelectedRowText.Substring(sSelectedRowText.Length - 2, 2) != "= ")
					txtAllocationEntityID.Text = sSelectedRowText.Substring(sSelectedRowText.IndexOf("=") + 2);

				panAllocationEntity.Visible = true;
			}
		}

		private void cmdSetAllocationEntity_Click(object sender, System.EventArgs e)
		{
			// Compose the row text

			string sSelectedRowText = lstAllocationEntityTypes.SelectedItem.ToString();
			string sNewRowText = sSelectedRowText.Substring(0, sSelectedRowText.IndexOf("=") + 2);
			sNewRowText += txtAllocationEntityID.Text.Trim();

			// Replace the existing row with the new one

			lstAllocationEntityTypes.Items.Insert(lstAllocationEntityTypes.SelectedIndex, sNewRowText);
			lstAllocationEntityTypes.Items.RemoveAt(lstAllocationEntityTypes.SelectedIndex);
			RefreshAllocationEntity();
		}

		private void cmdSaveTimeLog_Click(object sender, System.EventArgs e)
		{
			// Determine the log date in the required yyyymmdd format

			DateTime dLogDate = new DateTime();
			dLogDate = DateTime.Parse(txtLogDate.Text);
			string sLogDate = string.Format("{0:yyyyMMdd}", dLogDate);

			// Determine the allocation array for the log

			ttsystem.StringPair[] aAllocation = new ttsystem.StringPair[lstAllocationEntityTypes.Items.Count];
			for (int i = 0; i < lstAllocationEntityTypes.Items.Count; i++)
			{
				string sAllocationItem = lstAllocationEntityTypes.Items[i].ToString();

				// Parse out the entity type ID and the specified entity ID

				string sEntityTypeID = sAllocationItem.Substring(sAllocationItem.IndexOf("(UID") + 5, 16);
				string sEntityID = "";
				if (sAllocationItem.Length - sAllocationItem.IndexOf("= ") == 18)
					sEntityID = sAllocationItem.Substring(sAllocationItem.Length - 16);

				// Specify it in our array

				aAllocation[i] = new ttsystem.StringPair();
				aAllocation[i].ID = sEntityTypeID;
				aAllocation[i].Value = sEntityID;
			}

			// Blank custom field values

			ttsystem.StringPair[] aCustomFieldValues = new ttsystem.StringPair[1]; // leave blank

			// Issue the request

			ttsystem.ttsystem TTServer = new ttsystem.ttsystem();
			TTServer.Url = txtURL.Text + "/ttxml";
			ttsystem.SaveTimeLogOutput outSaveTimeLog = TTServer.SaveTimeLog(txtSessionID.Text, "", sLogDate, txtLogSeconds.Text, txtStatusDescription.Text, aAllocation, "", "", "", "", "0");
			AddResult("SaveTimeLog", outSaveTimeLog.Message + "(" + outSaveTimeLog.ResultCode + ")");
		}

		private void cmdGetTimeLogs_Click(object sender, System.EventArgs e)
		{
			ttsystem.ttsystem TTServer = new ttsystem.ttsystem();
			TTServer.Url = txtURL.Text + "/ttxml";
			TTServer.Timeout = System.Threading.Timeout.Infinite; // Disable timeout for long queries
			ttsystem.GetTimeLogsOutput outGetTimeLogs = TTServer.GetTimeLogs(txtSessionID.Text, "", dateGetTimeLogsFrom.Value.ToString("yyyyMMdd"), dateGetTimeLogsTo.Value.ToString("yyyyMMdd"), "7", "0", "");
			AddResult("GetTimeLogs", outGetTimeLogs.Message + "(" + outGetTimeLogs.ResultCode + ")");

			// Manually create the table from the returned time logs

			DataTable dt = new DataTable("TimeLogs");
			dt.Columns.Add("UID", Type.GetType("System.String"));
			dt.Columns.Add("LogDate", Type.GetType("System.String"));
			dt.Columns.Add("Duration", Type.GetType("System.String"));
			dt.Columns.Add("StatusDescription", Type.GetType("System.String"));

			for (int i = 0; i < outGetTimeLogs.TimeLogs.Length; i++)
			{
				DataRow dr = dt.NewRow();
				dr["UID"] = outGetTimeLogs.TimeLogs[i].UID;
				dr["LogDate"] = new DateTime(System.Convert.ToInt32(outGetTimeLogs.TimeLogs[i].LogSeq.Substring(0, 4)),
					System.Convert.ToInt32(outGetTimeLogs.TimeLogs[i].LogSeq.Substring(4, 2)),
					System.Convert.ToInt32(outGetTimeLogs.TimeLogs[i].LogSeq.Substring(6, 2)),
					0, 0, 0, 0).ToShortDateString();

				Double dDuration = System.Convert.ToDouble(outGetTimeLogs.TimeLogs[i].Duration) / (double)3600;
				dr["Duration"] = dDuration.ToString("0.0");
				dr["StatusDescription"] = outGetTimeLogs.TimeLogs[i].Description;
				dt.Rows.Add(dr);
			}
			
			gridTimeLogs.DataSource = dt;
			gridTimeLogs.PerformLayout();
		}

		private void cmdGetCustomFieldValuesEntity_Click(object sender, System.EventArgs e)
		{
			// Manually create the table

			DataTable dt = new DataTable("CustomFieldValues");
			dt.Columns.Add("CustomFieldID", Type.GetType("System.String"));
			dt.Columns.Add("SystemRef", Type.GetType("System.String"));
			dt.Columns.Add("FieldValue", Type.GetType("System.String"));

			// Get the entity details so we can figure out the type of entity it is

			ttsystem.ttsystem TTServer = new ttsystem.ttsystem();
			TTServer.Url = txtURL.Text + "/ttxml";
			ttsystem.GetEntityOutput outGetEntity = TTServer.GetEntity(txtSessionID.Text, txtCustomFieldEntityID.Text, "0");
			AddResult("GetEntity", outGetEntity.Message + "(" + outGetEntity.ResultCode + ")");

			// Get the list of entity custom fields
			
			ttsystem.GetEntityCustomFieldListOutput outGetEntityCustomFieldList = TTServer.GetEntityCustomFieldList(txtSessionID.Text, outGetEntity.EntityNode.EntityTypeID);
			AddResult("GetEntityCustomFieldList", outGetEntityCustomFieldList.Message + "(" + outGetEntityCustomFieldList.ResultCode + ")");
				
			// Iterate through each field

			for (int i = 0; i < outGetEntityCustomFieldList.CustomFields.Length; i++)
			{
				DataRow dr = dt.NewRow();
				dr["CustomFieldID"] = outGetEntityCustomFieldList.CustomFields[i].UID;
				dr["SystemRef"] = outGetEntityCustomFieldList.CustomFields[i].SystemRef;

				// Get the field value

				ttsystem.GetCustomFieldValueOutput outGetCustomFieldValue = TTServer.GetCustomFieldValue(txtSessionID.Text, outGetEntityCustomFieldList.CustomFields[i].UID, txtCustomFieldEntityID.Text);
				AddResult("GetCustomFieldValue", outGetCustomFieldValue.Message + "(" + outGetCustomFieldValue.ResultCode + ")");
				dr["FieldValue"] = outGetCustomFieldValue.FieldValue;
				dt.Rows.Add(dr);
			}

			gridCustomFieldValues.DataSource = dt;
			gridCustomFieldValues.PerformLayout();
		}

		private void gridTimeLogs_CurrentCellChanged(object sender, System.EventArgs e)
		{
			DataTable dt = (DataTable)gridTimeLogs.DataSource;
			DataRow dr = dt.Rows[gridTimeLogs.CurrentRowIndex];
			txtTimeLogID.Text = dr["UID"].ToString();
			if (txtTimeLogID.Text.Length > 0)
			{
				cmdGetTimeLogBilled.Enabled = true;
				cmdSetTimeLogBilled.Enabled = true;
				cmdClearTimeLogBilled.Enabled = true;
			}
			else
			{
				cmdGetTimeLogBilled.Enabled = false;
				cmdSetTimeLogBilled.Enabled = false;
				cmdClearTimeLogBilled.Enabled = false;
			}
		}

		private void cmdGetTimeLogBilled_Click(object sender, System.EventArgs e)
		{
			ttsystem.ttsystem TTServer = new ttsystem.ttsystem();
			TTServer.Url = txtURL.Text + "/ttxml";
			ttsystem.GetTimeLogBilledOutput outGetTimeLogBilled = TTServer.GetTimeLogBilled(txtSessionID.Text, txtTimeLogID.Text);
			AddResult("GetTimeLogBilled", outGetTimeLogBilled.Message + "(" + outGetTimeLogBilled.ResultCode + ")");
			if (System.Convert.ToInt32(outGetTimeLogBilled.ResultCode) >= 0) 
			{
				string sBillingStatus = "(not billed)";
				if (outGetTimeLogBilled.BilledOn.Length > 0)
					sBillingStatus = "Billed on " + outGetTimeLogBilled.BilledOn + " by User ID " + outGetTimeLogBilled.BilledBy;
				AddResult("TimeLog ID " + txtTimeLogID.Text, sBillingStatus);
			}
		}

		private void cmdSetTimeLogBilled_Click(object sender, System.EventArgs e)
		{
			SetTimeLogBilled(txtTimeLogID.Text, true);
		}

		private void cmdClearTimeLogBilled_Click(object sender, System.EventArgs e)
		{
			SetTimeLogBilled(txtTimeLogID.Text, false);
		}

		private void SetTimeLogBilled(string sTimeLogID, bool bBilled)
		{
			ttsystem.ttsystem TTServer = new ttsystem.ttsystem();
			TTServer.Url = txtURL.Text + "/ttxml";
			string sBilled = "0";
			if (bBilled)
				sBilled = "1";
			ttsystem.SetTimeLogBilledOutput outSetTimeLogBilled = TTServer.SetTimeLogBilled(txtSessionID.Text, txtTimeLogID.Text, sBilled);
			AddResult("SetTimeLogBilled", outSetTimeLogBilled.Message + "(" + outSetTimeLogBilled.ResultCode + ")");
		}

		private void GetEntityMetrics_Click(object sender, System.EventArgs e)
		{
			ttsystem.ttsystem TTServer = new ttsystem.ttsystem();
			TTServer.Url = txtURL.Text + "/ttxml";
			ttsystem.GetEntityMetricsOutput outGetEntityMetrics = TTServer.GetEntityMetrics(txtSessionID.Text, txtMetricsEntityID.Text, "");
			AddResult("GetEntityMetrics", outGetEntityMetrics.Message + "(" + outGetEntityMetrics.ResultCode + ")");
			if (System.Convert.ToInt32(outGetEntityMetrics.ResultCode) >= 0) 
			{
				txtMetricsAsOf.Text = outGetEntityMetrics.EntityMetrics.AsOf;
				txtMetricsTotalSecs.Text = outGetEntityMetrics.EntityMetrics.TotalSecs;
				txtMetricsCPI.Text = outGetEntityMetrics.EntityMetrics.CPI;
				txtMetricsSPI.Text = outGetEntityMetrics.EntityMetrics.SPI;
			}
		}

		private void txtFindEntityName_TextChanged(object sender, System.EventArgs e)
		{
			if (txtFindEntityName.Text.Length == 0)
			{
				gridFindEntities.DataSource = null;
				gridFindEntities.Refresh();
			}
			else
			{
				DataTable dt = new DataTable("FindEntities");
				dt.Columns.Add("UID", Type.GetType("System.String"));
				dt.Columns.Add("EntityName", Type.GetType("System.String"));
				dt.Columns.Add("EntityType", Type.GetType("System.String"));

				// Get the list of matching entities

				ttsystem.ttsystem TTServer = new ttsystem.ttsystem();
				TTServer.Url = txtURL.Text + "/ttxml";
				ttsystem.FindEntitiesByNameOutput outFindEntitiesByName = TTServer.FindEntitiesByName(txtSessionID.Text, txtFindEntityName.Text, "", "", "1");
				AddResult("FindEntitiesByName", outFindEntitiesByName.Message + "(" + outFindEntitiesByName.ResultCode + ")");
				if (System.Convert.ToInt32(outFindEntitiesByName.ResultCode) >= 0)
				{
					// Iterate through each field

					for (int i = 0; i < outFindEntitiesByName.EntityNodes.Length; i++)
					{
						DataRow dr = dt.NewRow();
						dr["UID"] = outFindEntitiesByName.EntityNodes[i].UID;
						dr["EntityName"] = outFindEntitiesByName.EntityNodes[i].EntityName;
						dr["EntityType"] = outFindEntitiesByName.EntityNodes[i].EntityTypeName;
						dt.Rows.Add(dr);
					}

					gridFindEntities.DataSource = dt;
					gridFindEntities.PerformLayout();
				}
			}
		}

		private void cmdGetRoleTypeList_Click(object sender, EventArgs e)
		{
			// Refresh the list of available role types

			ttsystem.ttsystem TTServer = new ttsystem.ttsystem();
			TTServer.Url = txtURL.Text + "/ttxml";
			ttsystem.GetRoleTypeListOutput outGetRoleTypeList = TTServer.GetRoleTypeList(txtSessionID.Text);
			AddResult("GetRoleTypeList", outGetRoleTypeList.Message + "(" + outGetRoleTypeList.ResultCode + ")");
			if (System.Convert.ToInt32(outGetRoleTypeList.ResultCode) < 0)
				return;

			// Add the types to our listbox

			cmbRoleTypes.Items.Clear();
			cmbRoleTypes.Text = "";
			for (int i = 0; i < outGetRoleTypeList.RoleTypes.Length; i++)
			{
				UniqueString theItem = new UniqueString(outGetRoleTypeList.RoleTypes[i].LanguageCaptions[0].Description);
				theItem.ID = outGetRoleTypeList.RoleTypes[i].UID;
				cmbRoleTypes.Items.Add(theItem);
			}

			// Select the last entity type

			if (outGetRoleTypeList.RoleTypes.Length > 0)
				cmbRoleTypes.SelectedIndex = outGetRoleTypeList.RoleTypes.Length - 1;
		}

		private void cmdAssign_Click(object sender, EventArgs e)
		{
			ttsystem.ttsystem TTServer = new ttsystem.ttsystem();
			TTServer.Url = txtURL.Text + "/ttxml";
			UniqueString s = (UniqueString)cmbRoleTypes.SelectedItem;
			ttsystem.CreateAssignmentOutput outCreateAssignment = TTServer.CreateAssignment(txtSessionID.Text, txtAssignFromEntityID.Text, txtAssignToEntityID.Text, s.ID);
			AddResult("CreateAssignment", outCreateAssignment.Message + "(" + outCreateAssignment.ResultCode + ")");
		}
	}

	public class UniqueString
	{
		public UniqueString(string s)
		{
			Value = s;
		}

		public string ID;
		public string Value;

		public override string ToString()
		{
			return Value;
		}
	}
}
